package bsoc.alpha;

import java.util.*;
import bsoc.division.*;
import bsoc.socsim.*;

/**
* A division with a simulation object
*/
public class AlphaDivision extends Division implements SocSimListener {

	AlphaSim sim = new AlphaSim ();
	
	public AlphaDivision () {
		Vector teams = new Vector();

		sim.addListener(this);

		teams.addElement(new AlphaTeam());
		teams.addElement(new AlphaTeam());
		teams.addElement(new AlphaTeam());
		teams.addElement(new AlphaTeam());
		teams.addElement(new AlphaTeam());
		setTeams(teams);

		sim.performEvent (SocSim.CHANGED_FOR_INFO);
		sim.performEvent (SocSim.CHANGED_FOR_GRAPHICS);
		
	}

	public void start () {
		sim.start();
		super.start();
	}

	public synchronized MatchResult play (Team teamWest, Team teamEast) {
		sim.setTeams(teamWest,teamEast);
		sim.restartMatch();
		try {
			wait();
		} catch (InterruptedException e) {
		}

		return new MatchResult (teamWest, teamEast, 0, 0);

	}

	public AlphaSim getSocSim () {
		return sim;
	}

	public synchronized void socSimPerformed (int id) {
		if (id == SocSim.STOPPED) 
			notify();
	}			

}
