package bsoc.alpha;

import bsoc.socsim.*;  
import bsoc.division.*;  
import EDU.gatech.cc.is.abstractrobot.*;

/**
* An alpha simulation. 
*/
public class AlphaSim extends SocSim {

	Team west, east;

	AlphaSim () {
		super();
	}

	/**
	* Does nothing. Prevents the simulation to be initialized with robots.
	*/
        public void initRobotsAtStartup() {}


	public void setTeams (Team west, Team east) {

		this.west = west;
		this.east = east;
		initValues();
		addAndInitRobots();
		setupSimulatedObjects ();
        }

	public void addAndInitRobots () {

		addAndInitRobotWest ((ControlSystemS)west.playerAt(0),0);
		addAndInitRobotWest ((ControlSystemS)west.playerAt(1),1);
		addAndInitRobotWest ((ControlSystemS)west.playerAt(2),2);
		addAndInitRobotWest ((ControlSystemS)west.playerAt(3),3);
		addAndInitRobotWest ((ControlSystemS)west.playerAt(4),4);

		addAndInitRobotEast ((ControlSystemS)east.playerAt(0),0);
		addAndInitRobotEast ((ControlSystemS)east.playerAt(1),1);
		addAndInitRobotEast ((ControlSystemS)east.playerAt(2),2);
		addAndInitRobotEast ((ControlSystemS)east.playerAt(3),3);
		addAndInitRobotEast ((ControlSystemS)east.playerAt(4),4);

		setupSimulatedObjects ();
        }

	public boolean matchShouldStop () {

		return (
			super.matchShouldStop() || 
			getSimulationSteps() > 3000
		);
			
	}
	

}	

