package bsoc.alpha;

import test.framework.*;
import bsoc.util.*;
import EDU.gatech.cc.is.abstractrobot.*;

/**
* Testcases for AlphaSim
*/
public class AlphaSimTest extends BsocTestCase {

        AlphaSimTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new AlphaSimTest ("testInit"));
                s.addTest (new AlphaSimTest ("testAddTeams"));
                s.addTest (new AlphaSimTest ("testRunnable"));
                return s;
        }

        protected void setUp () {
        }

	public void testInit () {
		ControlSystemS[] css;
		AlphaSim as = new AlphaSim();
		css = as.controlSystems();
		assert (css.length == 10);
		assert (css[0] == null);
		assert (css[1] == null);
		assert (css[2] == null);
		assert (css[3] == null);
		assert (css[4] == null);
		assert (css[5] == null);
		assert (css[6] == null);
		assert (css[7] == null);
		assert (css[8] == null);
		assert (css[9] == null);
        }

	public void testAddTeams () {
		ControlSystemS[] css;
		AlphaSim as = new AlphaSim();
		as.setTeams (new AlphaTeam(), new AlphaTeam());
		css = as.controlSystems();
		assert (css.length == 10);
		assert (css[0].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
		assert (css[1].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
		assert (css[2].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
		assert (css[3].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
		assert (css[4].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
		assert (css[5].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
		assert (css[6].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
		assert (css[7].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
		assert (css[8].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
		assert (css[9].getClass().toString().equals("class bsoc.alpha.AlphaPlayer"));
        }

	public synchronized void testRunnable () throws Exception{
		AlphaSim as = new AlphaSim();
		as.setTeams (new AlphaTeam(), new AlphaTeam());
		as.start();
		as.restartMatch();

		try {wait(1000);
		} 
		catch (InterruptedException e) {}

		as.stopMatch();
		assert (as.getWestscore() == 0);
		assert (as.getEastscore() == 0);
		assert (as.getTop() == 0.8625);
		assert (as.getBottom() == -0.8625);
		assert (as.getLeft() == -1.47);
		assert (as.getRight() == 1.47);
		assert (as.getCurrentTime() > 10);
		assert (as.getSimulationSteps() > 10);
		as.stopSimulation();
	}
}
