package bsoc.division;

import java.io.*;
import test.framework.*;
import bsoc.util.*;
import java.util.*;
 
/**
* Testcases.
*/
public class DTableEntryTest extends BsocTestCase {

	DTableEntry dte1, dte2, dte3;

        DTableEntryTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new DTableEntryTest ("testDTableEntryEquals"));
                s.addTest (new DTableEntryTest ("testDTableEntryEquals1"));
                s.addTest (new DTableEntryTest ("testDTableEntryEquals2"));
                s.addTest (new DTableEntryTest ("testDTableEntryEquals3"));
                s.addTest (new DTableEntryTest ("testDTableEntryEquals4"));
                s.addTest (new DTableEntryTest ("testDTableEntrySer0"));
                s.addTest (new DTableEntryTest ("testDTableEntrySer1"));
                s.addTest (new DTableEntryTest ("testDTableEntrySer2"));
                s.addTest (new DTableEntryTest ("testDTableEntrySer3"));
                s.addTest (new DTableEntryTest ("testDTableEntrySer4"));
                return s;
        }

        protected void setUp () {
		dte1 = new DTableEntry(new TestTeam(), 1);
		dte2 = new DTableEntry(new TestTeam(), 1);

		Team t = new TestTeam();
		t.addPlayer(new TestPlayer());
		dte3 = new DTableEntry(t, 2);
        }

	public void testDTableEntrySer1 () throws IOException, ClassNotFoundException {
		DTableEntry dte11;

		dte11 = (DTableEntry)writeAndRead(dte1);
		assert (dte1.equals(dte11));
		assert (dte11.equals(dte1));
        }

	public void testDTableEntrySer2 () throws IOException, ClassNotFoundException {
		DTableEntry dte11;

		dte1.addMatchResult (3, 1);
		dte11 = (DTableEntry)writeAndRead(dte1);
		assert (dte1.equals(dte11));
		assert (dte11.equals(dte1));
        }

	public void testDTableEntrySer3 () throws IOException, ClassNotFoundException {
		DTableEntry dte11;

		dte1.addMatchResult (1, 4);
		dte11 = (DTableEntry)writeAndRead(dte1);
		assert (dte1.equals(dte11));
		assert (dte11.equals(dte1));
        }

	public void testDTableEntrySer4 () throws IOException, ClassNotFoundException {
		DTableEntry dte11;

		dte1.addMatchResult (1, 1);
		dte1.addMatchResult (3, 1);
		dte1.addMatchResult (1, 4);
		dte1.addMatchResult (6, 1);
		dte11 = (DTableEntry)writeAndRead(dte1);
		assert (dte1.equals(dte11));
		assert (dte11.equals(dte1));
        }

	public void testDTableEntrySer0 () throws IOException, ClassNotFoundException {
		DTableEntry dte11;

		dte1.addMatchResult (1, 1);
		dte1.addMatchResult (3, 1);
		dte1.addMatchResult (1, 4);
		dte1.addMatchResult (6, 1);
		dte1.addMatchResult (1, 1);
		dte1.addMatchResult (3, 1);
		dte1.addMatchResult (1, 4);
		dte1.addMatchResult (6, 1);
		dte1.addMatchResult (1, 1);
		dte1.addMatchResult (3, 1);
		dte1.addMatchResult (1, 4);
		dte1.addMatchResult (6, 1);
		dte1.addMatchResult (1, 1);
		dte1.addMatchResult (3, 1);
		dte1.addMatchResult (1, 4);
		dte1.addMatchResult (6, 1);
		dte1.addMatchResult (1, 1);
		dte1.addMatchResult (3, 1);
		dte1.addMatchResult (1, 4);
		dte1.addMatchResult (6, 1);
		dte1.addMatchResult (1, 1);
		dte1.addMatchResult (3, 1);
		dte1.addMatchResult (1, 4);
		dte1.addMatchResult (6, 1);
		dte11 = (DTableEntry)writeAndRead(dte1);
		assert (dte1.equals(dte11));
		assert (dte11.equals(dte1));
        }

	public void testDTableEntryEquals () {

                assert (dte1.equals(dte2));
                assert (!dte1.equals(dte3));
        }

	public void testDTableEntryEquals1 () {

		dte1.addMatchResult (1, 1);
		dte2.addMatchResult (1, 1);
		dte3.addMatchResult (1, 1);
                assert (dte1.equals(dte2));
                assert (!dte1.equals(dte3));
        }

	public void testDTableEntryEquals2 () {

		dte1.addMatchResult (1, 1);
		dte2.addMatchResult (1, 2);
                assert (!dte1.equals(dte2));
                assert (!dte2.equals(dte1));
        }

	public void testDTableEntryEquals3 () {

		dte1.addMatchResult (1, 3);
		dte2.addMatchResult (1, 3);
                assert (dte1.equals(dte2));
                assert (dte2.equals(dte1));
        }

	public void testDTableEntryEquals4 () {

		dte1.addMatchResult (7, 3);
		dte2.addMatchResult (7, 3);
		dte1.addMatchResult (6, 3);
		dte2.addMatchResult (6, 3);
                assert (dte1.equals(dte2));
                assert (dte2.equals(dte1));
        }
 
}

