package bsoc.division;

import java.util.*;
import java.io.*;
import bsoc.division.*;

class SmallDiffDivision extends Division implements Serializable {

	Random ran = new Random ();
        double [] strength = {1, 0.95, 0.9, 0.85, 0.8};

	SmallDiffDivision () {
		super(createTeamsVector());
	}

	static Vector createTeamsVector () {
		Vector teams = new Vector ();
		int i;
		
		for (i=0;i<5;i++) {
			teams.addElement (new TestTeam());
		}
		return teams;
	}



	public MatchResult play (Team ta, Team tb) {
		int goalsA, goalsB, nra, nrb;
                double sa, sb, pa;

                sa = strength [teamIdForTeam(ta)];
                sb = strength [teamIdForTeam(tb)];
                pa = sa / (sa + sb);
                if (ran.nextDouble () < pa) {
		      goalsA = 1;
		      goalsB = 0;
                }
                else {
		      goalsA = 0;
		      goalsB = 1;
                }
		return new MatchResult (ta, tb, goalsA, goalsB);
	}

	public boolean shouldStop () {
		return (getPlayedMatches() < 2000);
	}

}

