package bsoc.division;

import java.util.*;
import java.io.*;

/**
* Manages a set of players who form a team.
*/
public class Team extends Object implements Serializable {

	Vector players = new Vector ();

 	public Team () {
		super ();
	}

	public int size () {
		return players.size ();
	}
	
	public void insertPlayerAt (Player p, int i) {
		players.insertElementAt (p, i);
	}
	
	public void addPlayer (Player p) {
		players.addElement (p);
	}
	
	public Player playerAt (int i) {
		return (Player)players.elementAt (i);
	}

	public String toString () {
		String str;
		int i;
		Player p;

		str = "[(Team) ";
		for (i=0; i<size (); i++) {
			p = playerAt (i);
			str += p.toString ();
		}
		str += "]";
		return str;
	}
	
        public boolean equals (Object o) {
		int i;
		Player p1, p2;
		Team team;		

                if (! (o instanceof Team)) return false;
                else {
			team = (Team)o;
			if (size() != team.size()) return false;
			else {
				for (i=0; i<size (); i++) {
					p1 = playerAt (i);
					p2 = team.playerAt (i);
					if (! p1.equals(p2)) return false;
				}
				return true;
			}
                }
        }
	

}

