package bsoc.division;

import java.io.*;
import java.util.*;

class TestDivision extends Division implements Serializable {

	Random ran = new Random (-1);

	TestDivision () {
		super(createTeamsVector());
	}

	static Vector createTeamsVector () {
		Vector teams = new Vector ();
		int i;
		
		for (i=0;i<5;i++) {
			teams.addElement (new TestTeam());
		}
		return teams;
	}


	public MatchResult play (Team ta, Team tb) {
		int goalsA, goalsB;

		goalsA = Math.abs (ran.nextInt ()) % 10;
		goalsB = Math.abs (ran.nextInt ()) % 10;
		return new MatchResult (ta, tb, goalsA, goalsB);
	}

	public boolean shouldStop () {
		return (getPlayedMatches() >= 100);
	}
}

