package bsoc.genetic;

import java.util.*;

/**
* Interface for Objects that have the capability to genereate Objects of the same
* type by applying genetic operations to parent objects. 
*/
public interface Crossable {

	/**
	* Creates a new instance of a new crossable object by applying
	* crossover and mutation on two parent objects.
	*/

	public Crossable newChild (Crossable otherParent, CrossoverSwitch cross, Mutator mut);

}	

