package bsoc.nn;

import java.util.*;
import java.io.*;

/**
* Is a neuron with no synapses. This means it can be used in the input-layer
* of a neuronal net.
*/

public class LayerNode implements Serializable  {
	
	short value;

	LayerNode (short val) {
		setValue (val);
	}

	LayerNode () {
		setValue ((short)0);
	}

	void setValue (short value) {
		if (value > Params.maxValue) {
			this.value = Params.maxValue;
		}
		else if (value < 0) {
			this.value = (short)0;
		}
		else { 
			this.value = value;
		}
	}

	void setValueRandom (RandomValue r) {
		setValue (r.nextValue ());
	}

	public short getValue () {
		return this.value;
	}

	public String toString () {
		if (isCalculated ()) {
			return ("<C" + this.value + ">");
		}
		else {
			return ("<U" + this.value + ">");
		}
	}

	String valueToString () {
		return (value + "");
	}

	boolean isConnectedToLayerNode (LayerNode ln) {
		return false;
	} 

	boolean isCalculated () {
		return true;
	} 

	void resetCalculated () {}
	void setCalculated () {}
	void calculate () {}

	void readObject(java.io.ObjectInputStream stream) throws IOException, ClassNotFoundException {}

	void writeObject(java.io.ObjectOutputStream stream) throws IOException {}

        public boolean equals (Object o) {
                return equalsInValue (o);
        }

        public boolean equalsInValue (Object o) {
                LayerNode ln;
 
                if (! (o instanceof LayerNode)) return false;
                else {
                        ln = (LayerNode)o;
                        if (ln.getValue () == getValue ()) return true;
                        else return false;
                }
        }

}

