
package bsoc.nn;

import java.io.*;
import bsoc.util.*;
import test.framework.*;

/**
* Testcases.
*/

public class LayerTest extends TestCase {

        Layer l1, l2, l3, l4;

        LayerTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new LayerTest ("testEquals"));
                s.addTest (new LayerTest ("testSerealize"));
                return s;
        }

        protected void setUp () {
                l1 = new Layer ();
                l1.addLayerNode (new LayerNode ((short)5));
                l1.addLayerNode (new LayerNode ((short)7));
                l1.addLayerNode (new LayerNode ((short)10));
                l1.addLayerNode (new LayerNode ((short)12));
                l1.addLayerNode (new LayerNode ((short)3));
                l1.addLayerNode (new LayerNode ((short)7));

                l2 = new Layer ();
                l2.addLayerNode (new LayerNode ((short)5));
                l2.addLayerNode (new LayerNode ((short)7));
                l2.addLayerNode (new LayerNode ((short)10));
                l2.addLayerNode (new LayerNode ((short)12));
                l2.addLayerNode (new LayerNode ((short)3));
                l2.addLayerNode (new LayerNode ((short)7));

                l3 = new Layer ();
                l3.addLayerNode (new LayerNode ((short)5));
                l3.addLayerNode (new LayerNode ((short)7));
                l3.addLayerNode (new LayerNode ((short)11));
                l3.addLayerNode (new LayerNode ((short)12));
                l3.addLayerNode (new LayerNode ((short)3));
                l3.addLayerNode (new LayerNode ((short)7));

                l4 = new Layer ();
                l4.addLayerNode (new LayerNode ((short)5));
                l4.addLayerNode (new LayerNode ((short)7));
                l4.addLayerNode (new LayerNode ((short)10));
                l4.addLayerNode (new LayerNode ((short)12));
                l4.addLayerNode (new LayerNode ((short)3));
        }

        public void testEquals () {
                assert (l1.equals (l1));
                assert (l1.equals (l2));
                assert (l2.equals (l1));
                assert (! l1.equals (l3));
                assert (! l1.equals (l4));
                assert (! l3.equals (l4));
        }
 
	public void testSerealize () throws IOException, ClassNotFoundException {
		RandomValue rv = new RandomValue (); 
		String file = "Layer.object";
		Layer l11 = new Layer ();

                assert (! l1.equals (l11));

		FileOutputStream ostream;
		FileInputStream istream;
		ObjectOutputStream po;
		ObjectInputStream pi;

		ostream = new FileOutputStream(file);
         	po = new ObjectOutputStream(ostream);
		po.writeObject (l1);
		po.flush();       
		ostream.close();
 
		istream = new FileInputStream(file);
		pi = new ObjectInputStream(istream);
		l11 = (Layer)pi.readObject();
		istream.close();
 
                assert (l11.equals (l1));

	}



}


