package bsoc.nn;

import java.io.*;
import bsoc.util.*;
import test.framework.*;

/**
* Testcases.
*/
public class NeuronTest extends TestCase {

        Neuron neu;
        Layer l;
 
        NeuronTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new NeuronTest ("statistics"));
                return s;
        }

        Neuron newNeuron (int synCount, double maxFactor, int stretch) {
                int i;
                Synapse syn;
                RandomWgt rw = new RandomWgt (-1);
                Weighter wgt = new Weighter (0, maxFactor);
                Transfer trn = new Transfer (stretch);
                Neuron neu;

                l = new Layer ();
                for (i=0; i<synCount; i++) {
                        l.addLayerNode (new LayerNode ());
                };
                neu = new Neuron (trn);
                for (i=0; i<synCount; i++) {
                        syn = new Synapse (wgt);
                        syn.connectLayerNode (l.layerNodeAt (i));
                        neu.addSynapse (syn);
                };
                neu .setWeightsRandom (rw);
                return neu;
        }

        void printBlock (int synCount, double maxFactor, int stretch, RandomValue rv, PrintStream ps) {
                Neuron neu;
                int i;

                neu = newNeuron (synCount, maxFactor, stretch);
                for (i=0; i<100; i++) {
                        l.setValuesRandom (rv);
                        neu.recalculate ();
                        ps.println (i+";"+synCount+";"+maxFactor+";"+stretch+";"+neu.getValue ());
                }
        }

        public void statistics () throws IOException {
		FileOutputStream os; 
		PrintStream ps;
		String fileName = "NeuStat.txt";
                RandomValue rv = new RandomValue ();

		os = new FileOutputStream (fileName); 
		ps = new PrintStream (os);
                ps.println ("nr;synCount;maxf;stretch;value");
                printBlock (20 , 1, 35, rv, ps);
                printBlock (20 , 1, 40, rv, ps);
                printBlock (20 , 1, 45, rv, ps);
                printBlock (20 , 1, 50, rv, ps);
                printBlock (20 , 1, 55, rv, ps);
                printBlock (20 , 1, 60, rv, ps);
		os.close (); 
                System.out.println ("--- Statistic results in "+fileName);
        }
}	
