package bsoc.nn;

import java.io.*;
import bsoc.util.*;
import test.framework.*;

/**
* Testcases.
*/
public class RandomTest extends TestCase {

	RandomValue rv;
	RandomWgt rw;


        RandomTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new RandomTest ("testValueMinMax"));
                s.addTest (new RandomTest ("testWeightMinMax"));
                return s;
        }

        protected void setUp () {
		rv = new RandomValue ();
		rw = new RandomWgt ();
        }


        public void testValueMinMax () {
		int i, n;
		short max, min, val;

		n = 1000;
		max = 0;
		min = Params.maxValue;
		for (i=1; i <=n; i++) {
			val = rv.nextValue ();
			if (val < min) min = val;
			if (val > max) max = val;
		}
                assert (min == 0);
                assert (max == Params.maxValue - 1);
        }
        public void testWeightMinMax () {
		int i, n;
		short max, min, val;

		n = 1000;
		max = 0;
		min = Params.maxWgt;
		for (i=1; i <=n; i++) {
			val = rw.nextValue ();
			if (val < min) min = val;
			if (val > max) max = val;
		}
                assert (min == -Params.maxWgt + 1);
                assert (max == Params.maxWgt - 1);
        }
}
		
