
package bsoc.nn;

import java.io.*;

class Synapse implements Serializable {

	Weighter weighter;

	short wgt;
	LayerNode ln;


        Synapse () {
                super();
        }

        Synapse (Weighter wgt) {
                weighter = wgt;
        }

	void connectLayerNode (LayerNode ln) {
		this.ln = ln;
	}

	LayerNode layerNode () {
		return ln;
	}

	void setWeight (short wgt) {
		this.wgt = wgt;
	}

	void setWeightRandom (RandomWgt rw) {
		setWeight (rw.nextValue ());
	}

	short getWeight () {
		return this.wgt;
	}

	int getWeightedCalculatedValue () {
		LayerNode ln;
		
		ln = layerNode ();
		ln.calculate ();
		return weighter.getWeightedValue (ln.getValue (), getWeight ());
	}	

	public String toString () {
		String str;
		if (ln == null) { str = "(." + this.wgt + ")";}
		else { str = "(*" + this.wgt + ")";};
		return str;
	}

        public boolean equals (Object o) {
                Synapse syn;
 
                if (! (o instanceof Synapse)) return false;
                else {
                        syn = (Synapse)o;
                        if (syn.getWeight () == getWeight ()) return true;
                        else return false;
                }
        }

	private void readObject(java.io.ObjectInputStream stream) throws IOException, ClassNotFoundException {
		setWeight (stream.readShort ());	
	} 

	private void writeObject(java.io.ObjectOutputStream stream) throws IOException {
		stream.writeShort (getWeight ());
 	}

}

