package bsoc.nn;

import java.io.*;
import bsoc.util.*;
import test.framework.*;

/**
* Testcases.
*/
public class SynapseTest extends TestCase {

        Synapse s1, s2, s3, s4, s5;
        LayerNode ln1, ln2, ln3;

        SynapseTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new SynapseTest ("testEquals"));
                s.addTest (new SynapseTest ("testSerial"));
                return s;
        }

        protected void setUp () {

                Weighter w = new Weighter ();
 
                ln1 = new LayerNode ((short)5);
                ln2 = new LayerNode ((short)6);
                ln3 = new LayerNode ((short)8);

                s1 = new Synapse (w);
                s2 = new Synapse (w);
                s3 = new Synapse (w);
                s4 = new Synapse (w);
                s5 = new Synapse (w);

                s1.setWeight ((short)0);
                s2.setWeight ((short)1);
                s3.setWeight ((short)6);
                s4.setWeight ((short)-6);
                s5.setWeight ((short)0);

                s5.connectLayerNode (ln1);
        }

        public void testEquals () {
                assert (s1.equals (s1));
                assert (! s1.equals (s2));
                assert (! s1.equals (s3));
                assert (! s1.equals (s4));
                assert (s1.equals (s5));
                assert (! s3.equals (s4));
        }
 
	public void testSerial () throws IOException, ClassNotFoundException {

		FileOutputStream ostream;
		FileInputStream istream;
		ObjectOutputStream po;
		ObjectInputStream pi;
		String file = "Synapse.object";
                Synapse s11;
                Synapse s12;
                Synapse s13;
                Synapse s14;
                Synapse s15;

		ostream = new FileOutputStream(file);
        	po = new ObjectOutputStream(ostream);
		po.writeObject (s1);
		po.writeObject (s2);
		po.writeObject (s3);
		po.writeObject (s4);
		po.writeObject (s5);
		po.flush();       
		ostream.close();
 
		istream = new FileInputStream(file);
		pi = new ObjectInputStream(istream);
		s11 = (Synapse)pi.readObject();
		s12 = (Synapse)pi.readObject();
		s13 = (Synapse)pi.readObject();
		s14 = (Synapse)pi.readObject();
		s15 = (Synapse)pi.readObject();
		istream.close();

                assert (s11.equals (s1));
                assert (s12.equals (s2));
                assert (s13.equals (s3));
                assert (s14.equals (s4));
                assert (s15.equals (s5));

	}

}		
