package bsoc.socsim;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import EDU.gatech.cc.is.abstractrobot.*;
import EDU.gatech.cc.is.simulation.*;

/**
* View for a socsim simulation.
*/
public class SocSimCanvas extends Canvas implements SocSimListener {

        private SocSim sim;
        private Image buffer;
        Graphics bufferg;
	private Color bcolor = new Color(48, 135, 55);

        SocSimCanvas (SocSim sim) {
                super ();
                this.sim = sim;
                sim.addListener (this);
        }

	public synchronized void update(Graphics g) {
                Image buffer;
		int size, i;
                SimulatedObject so;
		int w, h;
		double t, b, l, r;
 
		buffer = initBuffer ();

		w = getSize().width;
		h = getSize().height;
		t = sim.getTop ();
		b = sim.getBottom();
		l = sim.getLeft();
		r = sim.getRight();

		bufferg.setColor(bcolor);
		bufferg.fillRect(0, 0, w, h);

		for (i=0; i<sim.simulatedObjects().length; i++) {
			so = sim.simulatedObjects()[i];
			so.draw (bufferg, w, h, t, b, l, r);
		}
		g.drawImage(buffer, 0, 0, this);
		
	}

        public void socSimPerformed (int id) {
                if (id == SocSim.CHANGED_FOR_GRAPHICS) {
			repaint();
		}
        }

	public SocSim getSocSim () {
		return (sim);
	}

        Image initBuffer () {
                if (buffer == null) {
			buffer = createImage (1200, 800);
			bufferg = buffer.getGraphics();
		}
		return buffer;
        }

}


