
package bsoc.socsim;

import java.awt.*;
import java.awt.event.*;

class SocSimControlerPanel extends Panel implements ActionListener {

	private Button newButton;
	private SocSim sim;

	SocSimControlerPanel () {
		super ();
	}

	SocSimControlerPanel (SocSim sim) {
		this ();
	 	
		setSim (sim);

		setLayout (new GridLayout (1, 4));

		newButton = new Button ("Stop Match");
		newButton.addActionListener (this);
		add (newButton);

		newButton = new Button ("Restart Match");
		newButton.addActionListener (this);
		add (newButton);

		newButton = new Button ("Reset Match");
		newButton.addActionListener (this);
		add (newButton);

		newButton = new Button ("Update");
		newButton.addActionListener (this);
		add (newButton);

	}
	
	public void actionPerformed (ActionEvent e) {
		String cmd;

		cmd = e.getActionCommand ();
		if (cmd == "Stop Match") sim.stopMatch ();
		else if (cmd == "Restart Match") sim.restartMatch ();
		else if (cmd == "Reset Match") sim.resetMatch ();
		else if (cmd == "Update") {
			sim.performEvent (SocSim.CHANGED_FOR_INFO);
			sim.performEvent (SocSim.CHANGED_FOR_GRAPHICS);
		}
		else throw new Error ("Unknown action command '" + cmd +"'");
	}

	public void setSim (SocSim sim) {
		this.sim = sim;
	}

	public SocSim getSim () {
		return sim;
	}

}
