package bsoc.util;

import EDU.gatech.cc.is.simulation.*;

/**
* Contains selected instance values of the GolfBallSim.  
* This class was created to explore the states of a ball
* when a goal was shot.
* The class is not longer used.
* @see BallStateQueue
*/

public class BallState extends Object {

	boolean eastJustScored;
	boolean westJustScored;
	boolean eastKickOff;
	boolean westKickOff;
	boolean playBall;

	public BallState (GolfBallSim ball) {
		
		eastJustScored = ball.eastJustScored();
		westJustScored = ball.westJustScored();
		eastKickOff = ball.eastKickOff();
		westKickOff = ball.westKickOff();
		playBall = ball.playBall();
	}

	public String toString() {
		String s = new String ();
		
		s = "(";
		if (westJustScored) s += "T";
		else s += "F";
		if (eastJustScored) s += "T";
		else s += "F";
		s += " ";
		if (westKickOff) s += "T";
		else s += "F";
		if (eastKickOff) s += "T";
		else s += "F";
		s += " ";
		if (playBall) s += "T";
		else s += "F";
		s += ")";

		return s;
	}

	boolean justScored () {
		return (eastJustScored || westJustScored);
	}
	
}

		

	