package bsoc.util;

import EDU.gatech.cc.is.simulation.*;
import java.util.*;

/**
* Contains a FIFO queue of BallState. 
* This class was created to explore the states of a ball
* when a goal was shot.
* The class is not longer used.
* @see BallStateQueue
*/
public class BallStateQueue extends Object {

	int maxLength = 10;
	Vector queue = new Vector ();

	int counter = 0;
	boolean isCounting = false;

	public BallStateQueue (int maxLength) {
		setMaxLength (maxLength);
	}

	
	void setMaxLength (int maxLength) {
		if (maxLength < 5) this.maxLength = 5;
		else if (maxLength > 500) this.maxLength = 500;
		else this.maxLength = maxLength;
	}

	
	public void addBallState (GolfBallSim ball) {
		BallState bs;

		bs = new BallState (ball);
		if (queue.size() < maxLength) {
			queue.addElement (bs);
		}
		else if (queue.size() == maxLength) {
			queue.removeElementAt (0);
			queue.addElement (bs);
		}
		else throw new Error ("Queue length greater than maxLength");
		if (bs.justScored()) {
			isCounting = true;
			counter = 1;
		}
		if (isCounting) counter++;
		if (counter >= 5) {
			System.out.println (this);
			isCounting = false;
			counter = 0;	
		}
	}

	int size () {
		return queue.size();
	}
	
	Object elementAt (int i) {
		return queue.elementAt(i);
	}
	
	Enumeration ballStates () {
		return new BallStateEnum (this);
	}

	public String toString () {
		Enumeration ss;
		Object s;
		String str;
		str = "- - - - - - - - - - - - - - - - - - - - - - \n";
		str += "BallStateQueue maxLength=" + maxLength + "size=" + size() + "\n";
		str += "West / East \n";
		str += "JustScored / KickOff / PlayBall\n";
		ss = ballStates ();
		while (ss.hasMoreElements()) {
			s = ss.nextElement ();
			str += s.toString() + "\n";
		}
		str += "- - - - - - - - - - - - - - - - - - - - - - \n";
		return str;
	}
						
			
		
}

class BallStateEnum implements Enumeration {

	int index;
	BallStateQueue bsq;

	BallStateEnum (BallStateQueue bsq) {
		index = 0;
		this.bsq = bsq;
	}

	public boolean hasMoreElements () {
		return (index < bsq.size());
	}

	public Object nextElement () {
		return (bsq.elementAt (index++));
	}

}
 