package bsoc.util;

import java.io.*;
import test.framework.*;

/**
* Implements various service methods that can be used in many testcases. 
*/

public class BsocTestCase extends TestCase {


	/**
	* Creates a testcase with a specific name.
	* @param s The name for the new testcase.
	*/
	public BsocTestCase (String s) {
		super(s);
	}

	/**
	* Writes an object to a file and reads it afterwards.
	* Can be used to verify if a specific object is serializable.
	* The name of this file is always Serializable.object.
	* @param sIn The object.
	* @return The object that was read from the file.
	*/
	public Serializable writeAndRead (Serializable sIn) throws IOException, ClassNotFoundException {
		FileOutputStream fos;
		FileInputStream fis;
		ObjectOutputStream oos;
		ObjectInputStream pi;
		String file = "Serializable.object";
		Serializable sOut;

		fos = new FileOutputStream(file);
                oos = new ObjectOutputStream(fos);
		oos.writeObject (sIn);
		oos.flush();       
		fos.close();
 
		fis = new FileInputStream(file);
		pi = new ObjectInputStream(fis);
		sOut = (Serializable)pi.readObject();
		fis.close();

		return sOut;
	}

}

