package bsoc.util;

import java.util.*;

/**
* Converts a direction indicated by an int value into four values; A, B, C and
* D. These values are sinus curves between 0 and maxVal. The sinus curves do
* have a diffrent offset value.<p>
* A offset = 0 degree.<p>
* B offset = 90 degree.<p>
* C offset = 180 degree.<p>
* D offset = 270 degree.<p>
* By that the four values represent a direction with no preferences for any 
* direction.
*/

public class DirectionConverter extends Object {
 
        short[] vals = new short [360];

        public DirectionConverter (int maxVal) {
                initVals ((short)maxVal);
        }

        void initVals (short maxVal) {
                int i;
                double val;
                
                for (i=0; i<360; i++) {
                        val = (Math.sin (i * Math.PI / 180) / 2.0 + 0.5) * (maxVal - 1);
                        vals[i] = (short)val;
                }
        }

        public short getA (int in) {
                int i;
 
                i = (in + 90) % 360;
                if (i < 0) i += 360;
                return vals [i];
        }
        public short getB (int in) {
                int i;
 
                i = (in) % 360;
                if (i < 0) i += 360;
                return vals [i];
        }
        public short getC (int in) {
                int i;
 
                i = (in - 90) % 360;
                if (i < 0) i += 360;
                return vals [i];
        }
        public short getD (int in) {
                int i;
 
                i = (in +180) % 360;
                if (i < 0) i += 360;
                return vals [i];
        }
}

