package bsoc.util;

import java.io.*;

/**
* Returns a sequenze of integer pairs. The values of these integers are between
* 0 and a maximum value. The pairs contain the combinations of all integer valuses,
* but exclude those combinations containing the sane values. For max=3 IComb generates 
* [0,1], [0,2], [0,3], [1,2], [1,3], [2,3]
*/

public class IComb extends Object implements Serializable {

	int i = 0;
	int j = 1;
	int max;

	public IComb (int max) {
		this.max = max;
	}

	public IPair next () {
		IPair ip;
		ip = new IPair (i, j);
		j++;
		if (j >= max) {
			i++;
			if (i >= (max-1)) {
				i = 0; j = 1;
			}
			else j = i + 1;
		};	
		return ip;
	}

        public boolean equals (Object o) {
 
                if (! (o instanceof IComb)) return false;
                else {IComb ic = (IComb)o;
			if (
				(i == ic.i) &&
				(j == ic.j) &&
				(max == ic.max)) return true;
			else return false;
		}
        }


}

