package bsoc.util;

import java.io.*;
import test.framework.*;
/**
* Testcases.
*/
public class ICombTest extends BsocTestCase {
 
	IComb ic, ic1, ic2, ic3, ic4;

        ICombTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new ICombTest ("testResults"));
                s.addTest (new ICombTest ("testEquals1"));
                s.addTest (new ICombTest ("testEquals2"));
                s.addTest (new ICombTest ("testEquals3"));
                s.addTest (new ICombTest ("testSer1"));
                s.addTest (new ICombTest ("testSer2"));
                return s;
        }

        protected void setUp () {
                ic = new IComb (5);
                ic1 = new IComb (7);
                ic2 = new IComb (7);
                ic3 = new IComb (7);
                ic4 = new IComb (8);
        }

	public void testSer1 () throws IOException, ClassNotFoundException {
		IComb ic11;

		ic11 = (IComb)writeAndRead(ic1);
		assert (ic1.equals(ic11));
		assert (ic11.equals(ic1));
        }

	public void testSer2 () throws IOException, ClassNotFoundException {
		IComb ic11;
		int i;

		for (i=1; i<5; i++) {
			ic1.next();
		}
		ic11 = (IComb)writeAndRead(ic1);
		assert (ic1.equals(ic11));
		assert (ic11.equals(ic1));
        }

        public void testEquals1 () {
                assert (ic1.equals (ic1));
                assert (ic1.equals (ic2));
                assert (ic1.equals (ic3));
                assert (ic2.equals (ic1));
                assert (ic2.equals (ic3));
                assert (ic3.equals (ic1));
                assert (ic3.equals (ic2));
                assert (!ic1.equals (ic4));
                assert (!ic2.equals (ic4));
                assert (!ic3.equals (ic4));
                assert (ic4.equals (ic4));
        }

        public void testEquals2 () {
		int i;

		for (i=1; i<5; i++) {
			ic1.next();
			ic2.next();
		}
                assert (ic1.equals (ic2));
                assert (!ic1.equals (ic3));
                assert (!ic2.equals (ic3));
        }

        public void testEquals3 () {
		int i;

		for (i=1; i<5; i++) {
			ic1.next();
			ic2.next();
		}
		for (i=1; i<5; i++) {
			ic3.next();
			ic2.next();
		}
                assert (ic1.equals (ic3));
                assert (!ic1.equals (ic2));
                assert (!ic2.equals (ic3));
        }

        public void testResults () {
                IPair ip;

                ip = ic.next (); assert (ip.equals (new IPair (0, 1)));
        }


}


