package bsoc.util;

import test.framework.*;

/**
* Testcases.
*/
public class IntVectorTest extends BsocTestCase {
 
	IntVector iv1, iv2, iv3;

        IntVectorTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new IntVectorTest ("testEquals"));
                s.addTest (new IntVectorTest ("testIntAt"));
                s.addTest (new IntVectorTest ("testIntVectorAt"));
                s.addTest (new IntVectorTest ("testSetElementAt1"));
                s.addTest (new IntVectorTest ("testSetElementAt2"));
                s.addTest (new IntVectorTest ("testSetElementAt3"));
                s.addTest (new IntVectorTest ("testInsertElementAt1"));
                s.addTest (new IntVectorTest ("testInsertElementAt2"));
                s.addTest (new IntVectorTest ("testInsertElementAt3"));
                s.addTest (new IntVectorTest ("testAddElementAt1"));
                s.addTest (new IntVectorTest ("testAddElementAt2"));
                s.addTest (new IntVectorTest ("testAddElementAt3"));
                return s;
        }

        protected void setUp () {
		IntVector iv11, iv21, iv31;

		iv11 = new IntVector();
		iv11.addElement(1);
		iv11.addElement(2);
		iv11.addElement(3);
		iv11.addElement(4);
		iv1 = new IntVector();
		iv1.addElement(1);
		iv1.addElement(2);
		iv1.addElement(iv11);
		iv1.addElement(4);

		iv21 = new IntVector();
		iv21.addElement(1);
		iv21.addElement(2);
		iv21.addElement(3);
		iv21.addElement(4);
		iv2 = new IntVector();
		iv2.addElement(1);
		iv2.addElement(2);
		iv2.addElement(iv11);
		iv2.addElement(4);

		iv31 = new IntVector();
		iv31.addElement(1);
		iv31.addElement(2);
		iv31.addElement(3);
		iv31.addElement(4);
		iv3 = new IntVector();
		iv3.addElement(1);
		iv3.addElement(2);
		iv3.addElement(iv11);
		iv3.addElement(4);

        }

	public void testAddElementAt1 () {
		iv1.addElement(100);
		assert (iv1.size() == 5);
	}

	public void testAddElementAt2 () {
		iv1.addElement(100);
		assert (iv1.intAt(4) == 100);
	}

	public void testAddElementAt3 () {
		iv1.addElement(100);
		assert (iv1.intAt(0) == 1);
		assert (iv1.intAt(1) == 2);
		assert (iv1.intAt(3) == 4);
	}

	public void testInsertElementAt1 () {
		iv1.insertElementAt(100, 0);
		assert (iv1.size() == 5);
	}

	public void testInsertElementAt2 () {
		iv1.insertElementAt(100, 0);
		assert (iv1.intAt(0) == 100);
	}

	public void testInsertElementAt3 () {
		iv1.insertElementAt(100, 0);
		assert (iv1.intAt(1) == 1);
		assert (iv1.intAt(2) == 2);
		assert (iv1.intAt(4) == 4);
	}

	public void testSetElementAt1 () {
		iv1.setElementAt(100, 0);
		assert (iv1.size() == 4);
	}

	public void testSetElementAt2 () {
		iv1.setElementAt(100, 0);
		assert (iv1.intAt(0) == 100);
	}

	public void testSetElementAt3 () {
		iv1.setElementAt(100, 0);
		assert (iv1.intAt(1) == 2);
		assert (iv1.intAt(3) == 4);
	}

	public void testIntVectorAt () {
		IntVector iv11, iv21;
		iv11 = iv1.intVectorAt(2);
		iv21 = iv2.intVectorAt(2);
		assert (iv11.equals(iv21));
		assert (iv11.intAt(0) == iv21.intAt(0));
		assert (iv11.intAt(1) == iv21.intAt(1));
		assert (iv11.intAt(2) == iv21.intAt(2));
		assert (iv11.intAt(3) == iv21.intAt(3));
		assert (iv11.intAt(0) == 1);
		assert (iv11.intAt(1) == 2);
		assert (iv11.intAt(2) == 3);
		assert (iv11.intAt(3) == 4);
	}

        public void testIntAt () {
		assert (iv1.intAt(0) == 1);
		assert (iv1.intAt(1) == 2);
		assert (iv1.intAt(3) == 4);
		assert (iv2.intAt(0) == 1);
		assert (iv2.intAt(1) == 2);
		assert (iv2.intAt(3) == 4);
		assert (iv3.intAt(0) == 1);
		assert (iv3.intAt(1) == 2);
		assert (iv3.intAt(3) == 4);
        }

        public void testEquals () {
                assert (iv1.equals (iv1));
                assert (iv1.equals (iv2));
                assert (iv1.equals (iv3));
                assert (iv2.equals (iv1));
                assert (iv2.equals (iv2));
                assert (iv2.equals (iv3));
                assert (iv3.equals (iv1));
                assert (iv3.equals (iv3));
                assert (iv3.equals (iv2));
        }


}

 
