package bsoc.util;

import test.framework.*;
import java.util.*;
import java.io.*;

/**
* Testcases.
*/
public class SortableVectorTest extends BsocTestCase {
 
	SortableVector sv1, sv2, sv3;

        SortableVectorTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new SortableVectorTest ("testEquals"));
                s.addTest (new SortableVectorTest ("testSort0"));
                s.addTest (new SortableVectorTest ("testSort1"));
                s.addTest (new SortableVectorTest ("testSer0"));
                s.addTest (new SortableVectorTest ("testSer1"));
                s.addTest (new SortableVectorTest ("testSer2"));
                return s;
        }

        protected void setUp () {
                sv1 = new SortableVector ();
                sv1.addElement (new ComparableTestElement(0));
                sv1.addElement (new ComparableTestElement(2));
                sv1.addElement (new ComparableTestElement(3));
                sv1.addElement (new ComparableTestElement(4));
                sv1.addElement (new ComparableTestElement(3));
                sv1.addElement (new ComparableTestElement(4));
                sv1.addElement (new ComparableTestElement(5));
                sv1.addElement (new ComparableTestElement(6));
                sv2 = new SortableVector ();
                sv2.addElement (new ComparableTestElement(0));
                sv2.addElement (new ComparableTestElement(2));
                sv2.addElement (new ComparableTestElement(3));
                sv2.addElement (new ComparableTestElement(4));
                sv2.addElement (new ComparableTestElement(3));
                sv2.addElement (new ComparableTestElement(4));
                sv2.addElement (new ComparableTestElement(5));
                sv2.addElement (new ComparableTestElement(6));
                sv3 = new SortableVector ();
                sv3.addElement (new ComparableTestElement(0));
                sv3.addElement (new ComparableTestElement(2));
                sv3.addElement (new ComparableTestElement(3));
                sv3.addElement (new ComparableTestElement(4));
                sv3.addElement (new ComparableTestElement(3));
                sv3.addElement (new ComparableTestElement(4));
                sv3.addElement (new ComparableTestElement(5));
                sv3.addElement (new ComparableTestElement(6));
        }

        public void testEquals () {
                assert (sv1.equals (sv2));
                assert (sv1.equals (sv3));
                assert (sv2.equals (sv1));
                assert (sv2.equals (sv3));
                assert (sv3.equals (sv1));
                assert (sv3.equals (sv2));
        }

        public void testSort0 () {
		Enumeration enum;
		ComparableTestElement e1, e2;

		assert (!isSorted(sv1));
		sv1.sort();
		assert (isSorted(sv1));
	}

        public void testSort1 () {
		assert (sv1.equals(sv2));
		sv1.sort();
		assert (!sv1.equals(sv2));
		sv2.sort();
		assert (sv1.equals(sv2));
	}

	public void testSer0 () throws IOException, ClassNotFoundException {
		SortableVector sv11;

		sv11 = (SortableVector)writeAndRead(sv1);
		assert (sv1.equals(sv11));
		assert (sv11.equals(sv1));
        }

	public void testSer1 () throws IOException, ClassNotFoundException {
		SortableVector sv11;

		sv11 = (SortableVector)writeAndRead(sv1);
		sv11.sort();
		assert (!sv1.equals(sv11));
		sv1.sort();
		assert (sv11.equals(sv1));
        }

	public void testSer2 () throws IOException, ClassNotFoundException {
		SortableVector sv11;

		sv11 = (SortableVector)writeAndRead(sv1);
		sv11.sort();
		assert (!sv2.equals(sv11));
		sv2.sort();
		assert (sv2.equals(sv11));
        }

	static boolean isSorted (Vector v) {
		Enumeration enum;
		ComparableTestElement e1, e2;

		enum = v.elements();
		e1 = (ComparableTestElement)enum.nextElement();
		while (enum.hasMoreElements()) {
			e2 = (ComparableTestElement)enum.nextElement();
			if (e1.getValue() > e2.getValue()) return false;
			e1 = e2;
		}
		return true;
	}


}


