package bsoc.util;

import java.io.*;

/**
* Opens a file for writing.<p>
* Overriding the writeStat(PrintWriter) allows you to write the file without caring how to
* open this file.
*/


class StatFile extends Object {

	FileOutputStream os;
	public PrintWriter ps;
	String file;

        StatFile () {
                file = getFileName ();
                try {
                        os = new FileOutputStream (file);
                        ps = new PrintWriter (os);
                } catch (Exception e) {
                        System.out.println ("+++ StatFile: File "+file+" could not be opened");
                };
                writeStat ();
                System.out.println ("+++ StatFile: Statistics where written to "+file);
                try {
                        ps.close ();
                } catch (Exception e) {
                        System.out.println ("+++ StatFile: File "+file+" could not be closed");
                };
        }

        String getFileName () {
                return "StatFile.txt";
        }

	/**
	* Should be overridden.
	*/
        void writeStat () {
                writeStat (ps);
        }

        void writeStat (PrintWriter ps) {
                ps.println ("It is a nice day");
        }

	public static void main (String[] argv ) {
                Class cl;
                String className = "";
                StatFile sf;

                try {
                        className = argv[0];
                        System.out.println ("cn="+className);
                        cl = Class.forName (className);
                        sf = (StatFile)cl.newInstance ();
                }
                catch (Exception e) {
                        System.out.println ("+++ StatFile: Class "+className+" could not be created");
                }
	}

}


