package bsoc.xnet;

import bsoc.nn.*;
import bsoc.util.*;
import java.io.*;
import java.util.*;
import test.framework.*;

/**
* Testcases
*/
public class XNetTest extends TestCase {

        RandomValue rv;
        RandomWgt rw;

        XNetTest (String s) {
                super (s);
        }
 
        public static Test suite () {
                TestSuite s = new TestSuite ();
                s.addTest (new XNetTest ("runView"));
                s.addTest (new XNetTest ("runValues"));
                s.addTest (new XNetTest ("runConnStat"));
                return s;
        }

        protected void setUp () {

                rv = new RandomValue (293847);
                rw = new RandomWgt (23847);

        }

	public void runView () throws IOException {
		FileOutputStream os;
		PrintWriter ps;
		int i, j;
		String file = "View.txt";
                NetConnector nc = new SmallSquareConnector (-1, 15);
                Net n = new Net (nc);

		os = new FileOutputStream (file);
		ps = new PrintWriter (os);
		n.setWeightsRandom (new RandomWgt ());
                ps.println (n.toString ());
		os.close ();
		System.out.println ("--- View : Results in "+file);
	}

	public void runValues () throws IOException {
		FileOutputStream os;
		PrintWriter ps;
		int i, j;
		String file = "XNetVal.txt";
                NetConnector nc;
                Net n;

		os = new FileOutputStream (file);
		ps = new PrintWriter (os);
		ps.println ("type;nr;layer;neuron;value");
                for (j=0; j<10; j++) {
                        nc = new SmallSquareConnector (j, 20);
                        n = new Net (nc);
        		n.setWeightsRandom (rw);
        		for (i=0; i<=15; i++) {
	                      n.setInputLayerValuesRandom (rv);
        		      n.recalculate ();
			      valuesToStream (n, i, j, ps);
                        }
		}
		os.close ();
		System.out.println ("--- Values : Results in "+file);
	}

	void valuesToStream (Net net, int nr, int type, PrintWriter str) {
		Enumeration ls, lns;
		Layer l;
                LayerNode ln;
		int i, j;

		ls = net.layers ();
		i = 0; 
		while (ls.hasMoreElements ()) {
			l = (Layer)ls.nextElement ();
                        j = 0;
                        lns = l.layerNodes ();
                        while (lns.hasMoreElements ()) {
                                ln = (LayerNode)lns.nextElement ();
			        str.println (type+";"+nr+";"+i+";"+j+";"+ln.getValue());
                                j++;
                        }
			i++;
		}
	}

	public void runConnStat () throws IOException {
		FileOutputStream os;
		PrintWriter ps;
		String file = "ConnStat.txt";
                NetConnector nc = new SmallSquareConnector (-1, 20);
                Net n = new Net (nc);
	
		os = new FileOutputStream (file);
		ps = new PrintWriter (os);
		n.writeConnStatToStream (ps);
		os.close ();
		System.out.println ("--- Connection Statistics: Results in "+file);
	}
			
}


